coin = {}
-- coin variables
math.randomseed(os.time())
coin.timer = 0
coin.timerLim = math.random(3, 5)
coin.amount = math.random(1, 2)

-- sound effect
coin_collect = love.audio.newSource("res/coin.mp3")

function coin.generate(dt)
	-- spawn the coins
	coin.timer = coin.timer + dt

	if coin.timer > coin.timerLim then
		for i=1, coin.amount do
			coin.spawn(math.random(0, 600), math.random(-10, -200), math.random(100, 200))
		end
		coin.timer = 0
		coin.amount = math.random(1, 2)
	end
end
--

-- coin variables II
coin.width = 10
coin.height = 10
coin.speed = math.random(50,200)

function coin.spawn(x, y, speed)
	-- insert to the table
	table.insert(coin, {x = x, y = y, speed = speed })
end
--
function coin.draw()
	--draw each coin
	for i,v in ipairs(coin) do
		love.graphics.setColor(255,255,0)
		love.graphics.rectangle("fill", v.x, v.y, coin.width, coin.height)
	end
end
--
function coin.move(dt)
	-- move the coins
	for i,v in ipairs(coin) do
		v.y = v.y + v.speed * dt
	end
end
--
function coin.collide()
	-- player collision
	for i,v in ipairs(coin) do
		if v.x < player.x + player.width and
			player.x < v.x + coin.width and
			v.y < player.y + player.height and
			player.y < v.y + coin.height then
			table.remove(coin, i)
			love.audio.play(coin_collect)
			score = score + 1
		end
	end

	-- ground collision
	for i,v in ipairs(coin) do
		if v.x < 0 + 600 and
			0 < v.x + coin.width and
			v.y < 500 + 600 and
			500 < v.y + coin.height then
			table.remove(coin, i)
			GAME_OVER = true
		end
	end
end


-- PARENT FUNCTIONS
function DRAW_COIN()
	coin.draw()
end
function UPDATE_COIN(dt)
	coin.move(dt)
	coin.generate(dt)
	coin.collide()
end