player = {}

function player.load()
	-- player variables
	player.width = 32
	player.height = 64
	player.x = 0
	player.y = 432
	player.xvel = 0
	player.yvel = 0
	player.friction = 9.5
	player.speed = 19000
end
--
function player.draw()
	-- draw the player
	love.graphics.setColor(255,255,255)
	love.graphics.rectangle("fill", player.x, player.y, player.width, player.height)
end
--
function player.physics(dt)
	-- friction
	-- THANKS TO SOCKMUNKEE DEVELOPMENT FOR THE FRICTION CODE
	player.x = player.x + player.xvel * dt
	player.y = player.y + player.yvel * dt
	player.xvel = player.xvel * (1 - math.min(dt*player.friction, 1)) 
	player.yvel = player.yvel * (1 - math.min(dt*player.friction, 1)) 
end

function player.move(dt)
	-- move the player (derp)
	if love.keyboard.isDown("d") and player.xvel < player.speed * dt then
		player.xvel = player.xvel + player.speed * dt
	end
	if love.keyboard.isDown("a") and player.xvel > -player.speed * dt then
		player.xvel = player.xvel - player.speed * dt
	end
end
--
function player.boundarys()
	-- enclose the player
	if player.x < 0 - player.width then
		player.x = screenWidth
	end
	if player.x > screenWidth then
		player.x = 0 - player.width
	end
end

-- PARENT FUNCTIONS
function DRAW_PLAYER()
	player.draw()
end
function UPDATE_PLAYER(dt)
	player.physics(dt)
	player.move(dt)
	player.boundarys()
end